#ifndef __LIS_MATRIX_H__
#define __LIS_MATRIX_H__


#ifdef __cplusplus
extern "C"
{
#endif

	/****************************/
	/* Matrix Get Diagonal      */
	/****************************/
		extern int lis_matrix_get_diagonal_crs(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_ccs(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_msr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_dia(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_ell(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_jds(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_bsr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_bsc(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_vbr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_dns(LIS_MATRIX A, LIS_SCALAR d[]);
		extern int lis_matrix_get_diagonal_coo(LIS_MATRIX A, LIS_SCALAR d[]);
	/****************************/
	/* Matrix Scaling           */
	/****************************/
		extern void lis_matrix_scaling_crs(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_ccs(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_msr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_dia(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_ell(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_jds(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_bsr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_bsc(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_vbr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_dns(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_coo(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_crs(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_ccs(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_msr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_dia(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_ell(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_jds(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_bsr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_bsc(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_vbr(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_dns(LIS_MATRIX A, LIS_SCALAR d[]);
		extern void lis_matrix_scaling_symm_coo(LIS_MATRIX A, LIS_SCALAR d[]);
	/****************************/
	/* Matrix Split             */
	/****************************/
		extern int lis_matrix_split_crs(LIS_MATRIX A, LIS_VECTOR *D, LIS_MATRIX *L, LIS_MATRIX *U);
	/****************************/
	/* Matrix Convert           */
	/****************************/
		/***************/
		/* COO ==> dst */
		/***************/
		extern int lis_matrix_convert_coo2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_coo2ccs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_coo2msr(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		/***************/
		/* CRS ==> dst */
		/***************/
		extern int lis_matrix_convert_crs2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2dns(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2coo(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2ccs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2msr(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2dia(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2ell(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2jds(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_crs2vbr(LIS_MATRIX Ain, LIS_MATRIX *Aout, int bnr, int bnc, int *row, int *col);
		extern int lis_matrix_convert_crs2bsr(LIS_MATRIX Ain, LIS_MATRIX *Aout, int bnr, int bnc);
		extern int lis_matrix_convert_crs2bsc(LIS_MATRIX Ain, LIS_MATRIX *Aout, int bnr, int bnc);
		/***************/
		/* src ==> CRS */
		/***************/
		extern int lis_matrix_convert_dns2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_ccs2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_msr2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_dia2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_ell2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_jds2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_vbr2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_bsr2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_convert_bsc2crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
	/****************************/
	/* Matrix Copy              */
	/****************************/
		extern int lis_matrix_copy_crs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_ccs(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_msr(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_dia(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_ell(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_jds(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_bsr(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_bsc(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_vbr(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_coo(LIS_MATRIX Ain, LIS_MATRIX *Aout);
		extern int lis_matrix_copy_dns(LIS_MATRIX Ain, LIS_MATRIX *Aout);
	/****************************/
	/* Matrix Print             */
	/****************************/
		extern int lis_matrix_print_dns(LIS_MATRIX Amat);
		extern int lis_matrix_print_crs(LIS_MATRIX Amat);
		extern int lis_matrix_print_ccs(LIS_MATRIX Amat);
		extern int lis_matrix_print_msr(LIS_MATRIX Amat);
		extern int lis_matrix_print_coo(LIS_MATRIX Amat);
		extern int lis_matrix_print_dia(LIS_MATRIX Amat);
		extern int lis_matrix_print_ell(LIS_MATRIX Amat);
		extern int lis_matrix_print_jds(LIS_MATRIX Amat);
		extern int lis_matrix_print_bsr(LIS_MATRIX Amat);
		extern int lis_matrix_print_vbr(LIS_MATRIX Amat);
	/****************************/
	/* Matrix MPI               */
	/****************************/
	extern int lis_matrix_g2l(LIS_MATRIX A);
		extern int lis_matrix_g2l_crs(LIS_MATRIX A);
		extern int lis_matrix_g2l_msr(LIS_MATRIX A);
		extern int lis_matrix_g2l_dia(LIS_MATRIX A);
		extern int lis_matrix_g2l_ell(LIS_MATRIX A);
		extern int lis_matrix_g2l_jds(LIS_MATRIX A);
		extern int lis_matrix_g2l_bsr(LIS_MATRIX A);
		extern int lis_matrix_g2l_bsc(LIS_MATRIX A);
		extern int lis_matrix_g2l_vbr(LIS_MATRIX A);
		extern int lis_matrix_g2l_coo(LIS_MATRIX A);
		extern int lis_matrix_g2l_dns(LIS_MATRIX A);
	extern int lis_commtable_duplicate(LIS_MATRIX Ain, LIS_MATRIX *Aout);
	extern void lis_commtable_destroy(LIS_COMMTABLE *table);

	extern int lis_matrix_partitioned_crs(int my_rank, int nprocs, LIS_MATRIX *A);

#define PADD_JDS 32

#ifdef __cplusplus
}
#endif
#endif
