#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include "lis.h"
#include "lis_precon.h"


#define SAI_BLOCK 400

int lis_precon_create_sainv(LIS_PRECON precon)
{
	int i,j,k,ii,jj,ik,jk;
	int n,nnz;
	int err;
	int *ww;
//	int *il,*iu;
	int *cw,*maxcw;
	int *cz,*maxcz;
	int **iz,**iw;
	int *lptr,*lindex,*uptr,*uindex;
	LIS_SCALAR t,dd,tol_dd,tol;
	LIS_SCALAR *d;
	LIS_SCALAR *l,*u;
	LIS_SCALAR **z,**w;
	LIS_SCALAR *lvalue,*uvalue;
	LIS_MATRIX A;
	LIS_MATRIX B;
	double times,times1,times2,times3;

	A      = precon->Amat;
	n      = A->n;
	d      = precon->D->value;
	tol_dd = 0.455;
	tol    = precon->params[LIS_PARAMS_DROP]; 
//	tol    = 0.1;

	times1  = 0.0;
	times2 = 0.0;
	times3 = 0.0;
	

	lis_matrix_convert(A,&B, LIS_MATRIX_CCS,NULL);

	l     = (LIS_SCALAR *)lis_malloc(n*sizeof(LIS_SCALAR));
	u     = (LIS_SCALAR *)lis_malloc(n*sizeof(LIS_SCALAR));

	cw    = (int *)lis_malloc((n+1)*sizeof(int));
	maxcw = (int *)lis_malloc(n*sizeof(int));
	cz    = (int *)lis_malloc((n+1)*sizeof(int));
	maxcz = (int *)lis_malloc(n*sizeof(int));

	ww   = (int *)lis_malloc(n*sizeof(int));
//	il   = lis_malloc(n*sizeof(int));
//	iu   = lis_malloc(n*sizeof(int));
//	uptr = lis_malloc(n*sizeof(int));
	
	iw = (int **)lis_malloc(n*sizeof(int *));
	for(i=0;i<n;i++)
	{
		iw[i] = (int *)lis_malloc(_min(SAI_BLOCK,i+1)*sizeof(int));
	}
	w = (LIS_SCALAR **)lis_malloc(n*sizeof(LIS_SCALAR *));
	for(i=0;i<n;i++)
	{
		w[i] = (LIS_SCALAR *)lis_malloc(_min(SAI_BLOCK,i+1)*sizeof(LIS_SCALAR));
	}
	iz = (int **)lis_malloc(n*sizeof(int *));
	for(i=0;i<n;i++)
	{
		iz[i] = (int *)lis_malloc(_min(SAI_BLOCK,i+1)*sizeof(int));
	}
	z = (LIS_SCALAR **)lis_malloc(n*sizeof(LIS_SCALAR *));
	for(i=0;i<n;i++)
	{
		z[i] = (LIS_SCALAR *)lis_malloc(_min(SAI_BLOCK,i+1)*sizeof(LIS_SCALAR));
	}

	for(i=0;i<n;i++) ww[i] = 0;

	for(i=0;i<n;i++)
	{
		w[i][0]     = 1.0;
		iw[i][0] = i;
		cw[i]    = 1;
		maxcw[i] = _min(SAI_BLOCK,i+1);
	}
	for(i=0;i<n;i++)
	{
		z[i][0]     = 1.0;
		iz[i][0] = i;
		cz[i]    = 1;
		maxcz[i] = _min(SAI_BLOCK,i+1);
	}

	for(i=0; i<n; i++)
	{
		times = lis_wtime();

		/* l = Az_i */
//		srtr2(cz[i],iz[i],z[i]);

		memset(&l[i+1],0,(n-i-1)*sizeof(LIS_SCALAR));
		for(k=0;k<cz[i];k++)
		{
			ii = iz[i][k];
			for(j=B->ptr[ii];j<B->ptr[ii+1];j++)
			{
				jj = B->index[j];
				if( jj>i ) 
				{
					l[jj] += B->value[j]*z[i][k];
//					il[jj] = 1;
				}
			}
		}
		/*
		for(k=0;k<cz[i];k++)
		{
			ww[iz[i][k]] = k+1;
		}
		times1 += lis_cputime() - times;
		times   = lis_cputime();
		for(ii=i+1;ii<n;ii++)
		{
			t = 0.0;
			k = 0;
			for(j=A->ptr[ii];j<=uptr[ii];j++)
			{
				jj = ww[A->index[j]];
				if( jj!=0 )
				{
					t += A->value[j]*z[i][jj-1];
					k++;
					if( k==cz[i] ) break;
				}
			}
			l[ii] = t;
		}
		times2 += lis_cputime() - times;
		times   = lis_cputime();
		for(k=0;k<cz[i];k++)
		{
			ww[iz[i][k]] = 0;
		}
		times3 += lis_cputime() - times;
		*/

		/* u = w'_iA */
		memset(u,0,n*sizeof(LIS_SCALAR));
		for(k=0;k<cw[i];k++)
		{
			ii = iw[i][k];
			for(j=A->ptr[ii];j<A->ptr[ii+1];j++)
			{
				jj = A->index[j];
				u[jj] += A->value[j]*w[i][k];
			}
		}

		/* d_i = uz_i */
		t = 0.0;
		for(k=0;k<cz[i];k++)
		{
			t += u[iz[i][k]]*z[i][k];
		}
		d[i] = 1.0/t;
		times1 += lis_wtime() - times;
		times   = lis_wtime();

		// w_j = w_j - l_j/d_i w_i
		for(j=i+1;j<n;j++)
		{
			if( l[j]!=0.0 )
			{
				dd = l[j]*d[i];
//				if( dd > tol_dd )
				{
				for(k=0;k<cw[j];k++)
				{
					ww[iw[j][k]] = k+1;
				}
				for(ik=0;ik<cw[i];ik++)
				{
					jk = ww[iw[i][ik]];
					if( jk!=0 )
					{
						t = dd*w[i][ik];
//						if( fabs(t) > tol )
						if( fabs(w[j][jk-1] - t) > tol )
						{
							w[j][jk-1] -= t;
						}
						else
						{
							w[j][jk-1] = 0.0;
						}
					}
					else
					{
						t = dd*w[i][ik];
						if( fabs(t) > tol )
						{
							if( cw[j] == maxcw[j] )
							{
								w[j]      = realloc(w[j], (maxcw[j]+SAI_BLOCK)*sizeof(LIS_SCALAR));
								iw[j]     = realloc(iw[j],(maxcw[j]+SAI_BLOCK)*sizeof(int));
								maxcw[j] += SAI_BLOCK;
							}
							jk        = cw[j];
							iw[j][jk] = iw[i][ik];
							w[j][jk]  = -t;
							cw[j]++;
						}
					}
				}
				for(k=0;k<cw[j];k++)
				{
					ww[iw[j][k]] = 0;
				}
				}
			}
		}
		times2 += lis_wtime() - times;
		times   = lis_wtime();

		// z_j = z_j - u_j/d_i z_i
		for(j=i+1;j<n;j++)
		{
			if( u[j]!=0.0 )
			{
				dd = u[j]*d[i];
//				if( dd > tol_dd )
				{
				for(k=0;k<cz[j];k++)
				{
					ww[iz[j][k]] = k+1;
				}
				for(ik=0;ik<cz[i];ik++)
				{
					jk = ww[iz[i][ik]];
					if( jk!=0 )
					{
						t = dd*z[i][ik];
//						if( fabs(t) > tol )
						if( fabs(z[j][jk-1] - t) > tol )
						{
							z[j][jk-1] -= t;
						}
						else
						{
							z[j][jk-1] = 0.0;
						}
					}
					else
					{
						t = dd*z[i][ik];
						if( fabs(t) > tol )
						{
							if( cz[j] == maxcz[j] )
							{
								z[j]      = realloc(z[j], (maxcz[j]+SAI_BLOCK)*sizeof(LIS_SCALAR));
								iz[j]     = realloc(iz[j],(maxcz[j]+SAI_BLOCK)*sizeof(int));
								maxcz[j] += SAI_BLOCK;
							}
							jk        = cz[j];
							iz[j][jk] = iz[i][ik];
							z[j][jk]  = -t;
							cz[j]++;
						}
					}
				}
				for(k=0;k<cz[j];k++)
				{
					ww[iz[j][k]] = 0;
				}
				}
			}
		}
		times3 += lis_wtime() - times;
		times   = lis_wtime();
	}

//	printf("times1 = %e times2 = %e times3 = %e\n",times1,times2,times3);

	nnz = 0;
	for(i=0;i<n;i++) nnz += cw[i];

	err = lis_matrix_create(n,0,A->comm,&precon->L);
	if( err )
	{
		return LIS_OUT_OF_MEMORY;
	}
	lvalue = (LIS_SCALAR *)lis_malloc(nnz*sizeof(LIS_SCALAR));
	lindex = (int *)lis_malloc(nnz*sizeof(int));
	lptr   = (int *)lis_malloc((n+1)*sizeof(int));

	lptr[0] = 0;
	for(i=0;i<n;i++)
	{
		lptr[i+1] = lptr[i] + cw[i];
	}
	k = 0;
	for(i=0;i<n;i++)
	{
		for(j=0;j<cw[i];j++)
		{
			lindex[k] = iw[i][j];
			lvalue[k] = w[i][j];
			k++;
		}
	}
	lis_matrix_set_ccs(nnz,lptr,lindex,lvalue,precon->L);
	lis_matrix_assemble(&precon->L,LIS_MATRIX_CCS);

	nnz = 0;
	for(i=0;i<n;i++) nnz += cz[i];

	err = lis_matrix_create(n,0,A->comm,&precon->U);
	if( err )
	{
		return LIS_OUT_OF_MEMORY;
	}
	uvalue = (LIS_SCALAR *)lis_malloc(nnz*sizeof(LIS_SCALAR));
	uindex = (int *)lis_malloc(nnz*sizeof(int));
	uptr   = (int *)lis_malloc((n+1)*sizeof(int));

	uptr[0] = 0;
	for(i=0;i<n;i++)
	{
		uptr[i+1] = uptr[i] + cz[i];
	}
	k = 0;
	for(i=0;i<n;i++)
	{
		for(j=0;j<cz[i];j++)
		{
			uindex[k] = iz[i][j];
			uvalue[k] = z[i][j];
			k++;
		}
	}
	lis_matrix_set_ccs(nnz,uptr,uindex,uvalue,precon->U);
	lis_matrix_assemble(&precon->U,LIS_MATRIX_CCS);

	lis_matrix_destroy(B);
	lis_free(l);
	lis_free(u);
	lis_free(ww);
	lis_free(cw);
	lis_free(maxcw);
	lis_free(cz);
	lis_free(maxcz);
	for(i=0;i<n;i++)
	{
		lis_free(iw[i]);
		lis_free(w[i]);
		lis_free(iz[i]);
		lis_free(z[i]);
	}
	lis_free(iw);
	lis_free(w);
	lis_free(iz);
	lis_free(z);
	return LIS_SUCCESS;
}

void lis_psolve_sainv(LIS_PRECON precon, LIS_VECTOR b, LIS_VECTOR x)
{
	int i,n;
	LIS_SCALAR *t,*d;

	/*
	 *  x  = Mb
	 *  M  = ZD^-1W'
	 */

	n = precon->Amat->n;
	t = precon->temp->value;
	d = precon->D->value;
//	lis_matvect(precon->U,b,t);
	lis_matvect(precon->L,b,precon->temp);
#pragma omp parallel for private(i)
	for(i=0;i<n;i++)
	{
		t[i] = d[i]*t[i];
	}
	lis_matvec(precon->U,precon->temp,x);
}

void lis_psolvet_sainv(LIS_PRECON precon, LIS_VECTOR b, LIS_VECTOR x)
{
	int i,n;
	LIS_SCALAR *t,*d;

	/*
	 *  x  = M'b
	 *  M' = WD^-1Z'
	 */

	n = precon->Amat->n;
	t = precon->temp->value;
	d = precon->D->value;
	lis_matvect(precon->U,b,precon->temp);
#pragma omp parallel for private(i)
	for(i=0;i<n;i++)
	{
		t[i] = d[i]*t[i];
	}
	lis_matvec(precon->U,precon->temp,x);
	lis_free(t);
}

