#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <malloc.h>
#include "lis.h"

#define lis_swap(a,b,t) {t = a; a = b; b = t;}

void lis_sort_i(int is, int ie, int *i1)
{
	int i,j;
	int p,t1;
	int v;

	if( ie <= is ) return;

	p = (is+ie)/2;
	v = i1[p];
	lis_swap(i1[p],i1[ie],t1);

	i = is;
	for(j=is;j<ie;j++)
	{
		if( i1[j] <= v )
		{
			lis_swap(i1[i],i1[j],t1);
			i++;
		}
	}
	lis_swap(i1[ie],i1[i],t1);

	lis_sort_i(is,i-1,i1);
	lis_sort_i(i+1,ie,i1);
}

void lis_sort_id(int is, int ie, int *i1, LIS_SCALAR *d1)
{
	int i,j;
	int p,t1;
	int v;
	LIS_SCALAR s1;

	if( ie <= is ) return;

	p = (is+ie)/2;
	v = i1[p];
	lis_swap(i1[p],i1[ie],t1);
	lis_swap(d1[p],d1[ie],s1);

	i = is;
	for(j=is;j<ie;j++)
	{
		if( i1[j] <= v )
		{
			lis_swap(i1[i],i1[j],t1);
			lis_swap(d1[i],d1[j],s1);
			i++;
		}
	}
	lis_swap(i1[ie],i1[i],t1);
	lis_swap(d1[ie],d1[i],s1);

	lis_sort_id(is,i-1,i1,d1);
	lis_sort_id(i+1,ie,i1,d1);
}


void lis_sort_ii(int is, int ie, int *i1, int *i2)
{
	int i,j;
	int p,t1,t2;
	int v;

	if( ie <= is ) return;

	p = (is+ie)/2;
	v = i1[p];
	lis_swap(i1[p],i1[ie],t1);
	lis_swap(i2[p],i2[ie],t2);

	i = is;
	for(j=is;j<ie;j++)
	{
		if( i1[j] <= v )
		{
			lis_swap(i1[i],i1[j],t1);
			lis_swap(i2[i],i2[j],t2);
			i++;
		}
	}
	lis_swap(i1[ie],i1[i],t1);
	lis_swap(i2[ie],i2[i],t2);

	lis_sort_ii(is,i-1,i1,i2);
	lis_sort_ii(i+1,ie,i1,i2);
}

void lis_sort_iid(int is, int ie, int *i1, int *i2, LIS_SCALAR *d1)
{
	int i,j;
	int p,t1,t2;
	int v;
	LIS_SCALAR s1;

	if( ie <= is ) return;

	p = (is+ie)/2;
	v = i1[p];
	lis_swap(i1[p],i1[ie],t1);
	lis_swap(i2[p],i2[ie],t2);
	lis_swap(d1[p],d1[ie],s1);

	i = is;
	for(j=is;j<ie;j++)
	{
		if( i1[j] <= v )
		{
			lis_swap(i1[i],i1[j],t1);
			lis_swap(i2[i],i2[j],t2);
			lis_swap(d1[i],d1[j],s1);
			i++;
		}
	}
	lis_swap(i1[ie],i1[i],t1);
	lis_swap(i2[ie],i2[i],t2);
	lis_swap(d1[ie],d1[i],s1);

	lis_sort_iid(is,i-1,i1,i2,d1);
	lis_sort_iid(i+1,ie,i1,i2,d1);
}

void lis_sort_iiid(int is, int ie, int *i1, int *i2, int *i3, LIS_SCALAR *d1)
{
	int i,j;
	int p,t1,t2,t3;
	int v;
	LIS_SCALAR s1;

	if( ie <= is ) return;

	p = (is+ie)/2;
	v = i1[p];
	lis_swap(i1[p],i1[ie],t1);
	lis_swap(i2[p],i2[ie],t2);
	lis_swap(i3[p],i3[ie],t3);
	lis_swap(d1[p],d1[ie],s1);

	i = is;
	for(j=is;j<ie;j++)
	{
		if( i1[j] <= v )
		{
			lis_swap(i1[i],i1[j],t1);
			lis_swap(i2[i],i2[j],t2);
			lis_swap(i3[i],i3[j],t3);
			lis_swap(d1[i],d1[j],s1);
			i++;
		}
	}
	lis_swap(i1[ie],i1[i],t1);
	lis_swap(i2[ie],i2[i],t2);
	lis_swap(i3[ie],i3[i],t3);
	lis_swap(d1[ie],d1[i],s1);

	lis_sort_iiid(is,i-1,i1,i2,i3,d1);
	lis_sort_iiid(i+1,ie,i1,i2,i3,d1);
}

void lis_sortr_ii(int is, int ie, int *i1, int *i2)
{
	int i,j;
	int p,t1,t2;
	int v;

	if( ie <= is ) return;

	p = (is+ie)/2;
	v = i1[p];
	lis_swap(i1[p],i1[ie],t1);
	lis_swap(i2[p],i2[ie],t2);

	i = is;
	for(j=is;j<ie;j++)
	{
		if( i1[j] >= v )
		{
			lis_swap(i1[i],i1[j],t1);
			lis_swap(i2[i],i2[j],t2);
			i++;
		}
	}
	lis_swap(i1[ie],i1[i],t1);
	lis_swap(i2[ie],i2[i],t2);

	lis_sortr_ii(is,i-1,i1,i2);
	lis_sortr_ii(i+1,ie,i1,i2);
}

